#!/usr/bin/env python
# -*- coding: utf-8 -*-

from PyQt4 import QtCore, QtGui

APPNAME = "qControlCenter"
VERSION = "v0.1"

class helpDialog(QtGui.QDialog):
	def __init__(self, parent):
		QtGui.QDialog.__init__(self, parent)
		
		title = QtGui.QLabel(
			"<table><tr>"
			"<td><img src='icons/abs-logo.png'></td><td<&nbsp;</td>"
			"<td><BIG><b>Control Panel for Absolute</b><BIG></td>"
			"</tr></table>"
		)
		self.setWindowTitle('About the Control Panel')

		pbClose = QtGui.QPushButton("&Close")
		
		tabWidget = QtGui.QTabWidget(self)
		tabWidget.addTab(self.tabAbout(),"About")
		tabWidget.addTab(self.tabInstructions(),"Instructions")
		tabWidget.addTab(self.tabLicense(),"License")
		
		hlay = QtGui.QHBoxLayout()
		hlay.addStretch()
		hlay.addWidget(pbClose)
		
		vlay = QtGui.QVBoxLayout()
		vlay.addWidget(title)
		vlay.addWidget(tabWidget)
		vlay.addLayout(hlay)
		
		self.connect(pbClose, QtCore.SIGNAL("clicked()"), QtCore.SLOT("close()"))
		self.setLayout(vlay)
		self.setModal(True)
		self.setMinimumSize(512,360)

	def tabAbout(self):
		tab = QtGui.QWidget()
		label = QtGui.QLabel(
			"<P>Built atop the code for &nbsp;" + APPNAME + "&nbsp;" + VERSION + "</i><br>(c) 2008 Thierry Deseez</P>"
			"<br><br>...with some tweaks, some enhancements and a bit of hacking about.<br><br>"
			"<br><br>There is a root-user version and a regular user version made for Absolute.<br>"
			"As you can imagine, the version that pops up for root has MANY more options.<br>"
			"<br><br>The app is technically a good-looking shell you can drop your utility applications into.<br>"
			"Basically uses .desktop files put into your home dir under the folder &quot;.abscontrolcenter&quot;<br>"
			"It should be noted that if you make command arguments in your .desktop files you do<br>NOT need to prefix them "
			"with <i>sh -c</i> as commands are not parsed in the same manner.<br>A simple call string with escaped "
			"quotes will do. You can check out some of the system<br>utilities that use xterm calls to see what I mean."
		)
		vlay = QtGui.QVBoxLayout()
		vlay.addWidget(label)
		
		tab.setLayout(vlay)
		
		return tab
	
	def tabInstructions(self):
		tab = QtGui.QWidget()
		textView = QtGui.QTextBrowser()
		textContent = QtCore.QString("")
		vlay = QtGui.QVBoxLayout()
		
		file = QtCore.QFile("data/INSTRUCTIONS.txt")
		if file.open(QtCore.QIODevice.ReadOnly | QtCore.QIODevice.Text):
			while not file.atEnd():
				textContent.append( QtCore.QString.fromUtf8( file.readLine().data() ) )

		textView.setText(textContent)
		textContent = None
		vlay.addWidget(textView)
		tab.setLayout(vlay)
		
		return tab
	
	def tabLicense(self):
		tab = QtGui.QWidget()
		textView = QtGui.QTextBrowser()
		textContent = QtCore.QString("")
		vlay = QtGui.QVBoxLayout()
		
		file = QtCore.QFile("data/LICENSE.html")
		if file.open(QtCore.QIODevice.ReadOnly | QtCore.QIODevice.Text):
			while not file.atEnd():
				textContent.append( QtCore.QString.fromUtf8( file.readLine().data() ) )

		textView.setHtml(textContent)
		textContent = None
		
		vlay.addWidget(textView)
		tab.setLayout(vlay)
		
		return tab